#include <vector>
#include <iostream>

typedef std::vector<std::string> ArrayOfString;

class MyClass {
    public:
        void doSomething(){}
} ;

MyClass* getInstance() { return new MyClass(); }
auto getInstanceWithAuto() { return new MyClass(); }

/// Automatic deduction of the type
int main(int, char**)
{
    /// c++03
    MyClass a = MyClass();
    a.doSomething();

    /// c++11
    auto b = MyClass();
    b.doSomething();

    /// c++03 iteration over structure style
    ArrayOfString as = {"one", "two", "three"};
    ArrayOfString::iterator it = as.begin();
    ArrayOfString::iterator end = as.end();
    for( ; it!=end ; ++it)
        std::cout << *it << std::endl;

    /// c++11 type inference
    auto it2 = as.begin();
    auto end2 = as.end();
    for( ; it2!=end2 ; ++it2)
        std::cout << *it2 << std::endl;

    /// auto can be deduced from returned type
    auto r = getInstance();
    r->doSomething();

    auto r2 = getInstanceWithAuto();
    r2->doSomething();

    delete r;
    delete r2;
}
