
#include <vector>
#include <iostream>

class A
{
public:
    virtual ~A(){}
    virtual void aMethod() const { std::cout << "A" << std::endl; }
};

/// The c++03 version
class B : public A
{
public:
    virtual ~B(){}
    virtual void aMethod() const { std::cout << "B" << std::endl; }
};

/// The c++11 version use the "override" keyword
class C : public A
{
public:
    virtual ~C(){}
    void aMethod() const override { std::cout << "C" << std::endl; }
};

/// The c++11 version use the "override" keyword
class D : public C
{
public:
    virtual ~D(){}
    void aMethod() const { std::cout << "D" << std::endl; }
};



void callMethod(const A& a)
{
    a.aMethod();
}

int main(int, char**)
{
    callMethod(A());
    callMethod(B());
    callMethod(C());
}
