#include <iostream>
#include <chrono>
using namespace std::chrono_literals;

class Meters
{
public:
    double value;
    Meters(double m){ value = m; }
};

Meters operator"" _m(long double mt)
{
    return Meters(static_cast<double>(mt));
}

Meters operator"" _inches(long double mt)
{
    return Meters(static_cast<double>(mt)*0.0254);
}

Meters operator"" _km(long double mt)
{
    return Meters(static_cast<double>(mt)*1000.0);
}


int main(int, char**)
{
    /// 'f' is a 'literal'
    float value = 25.0f;

    /// In c++11 we can make user defined literals
    Meters dimmension1 = 3;
    Meters dimmension2 = 3.0_m;
    Meters dimmension3 = 3.0_km;
    Meters dimmension4 = 3.0_inches;

    /// This is used in the stl (eg: chronos)
    auto presentationTime = 0s;
    presentationTime = 60min;
    std::cout << "the presentation is " << presentationTime.count() << " seconds" << std::endl;
}
